const fs = require('fs');
const os = require('os');
const path = require('path');
const user_homedir = os.homedir();
const scheduleControl = require('./processSchedule');
const previewService = require('./processPreview'); //訊源模組
const screenService = require('./processScreen'); //版型切換模組
const recordService = require('./processRecord'); //錄影模組
const liveService = require('./processLive');//直播模組
const ptzService = require('./processPTZ');//鏡頭旋轉模組
const getPreset = require('./getPreset');//取得攝影機現在位置
const autoExec = require('node-schedule');
const mysql = require('mysql');
const WebSocket = require('ws');
const { start } = require('repl');
const wss = new WebSocket.Server({ port: 8893 }, () => { console.log('Server start!'); });
var plan = 3;
var area = '0';
var audio_mode = undefined;
var camera1 = undefined;
var camera2 = undefined;
var desktop = undefined;
var microphone = undefined;

var preview_first_start = false;
var preview_start_time = false;
var start_hours = undefined;

const mysql_pool = mysql.createPool({
  host: 'localhost',
  user: 'root',
  password: 'zang670623',
  database: 'zrs'
});

try {

    start_hours = new Date().getHours();

    if (start_hours < 22 && start_hours > 8) {

        preview_first_start = true;

    } else {

        preview_first_start = false;

    }


	/*
	
	
    let temp = fs.readFileSync(path.resolve(user_homedir + '\\Documents', 'user.txt'), 'utf8');

    let data_array = temp.split(',');

    area = data_array[0];

    audio_mode = data_array[1];

    switch (audio_mode) {

        case 'first_card':

            camera1 = 'AVerMedia Live Gamer HD 2';
            camera2 = 'AVerMedia Live Gamer HD 2';
            desktop = 'none';
            microphone = '線路 (AVerMedia Live Gamer HD 2)';

            break;

        case 'second_card':

            camera1 = 'AVerMedia Live Gamer HD 2';
            camera2 = 'AVerMedia Live Gamer HD 2';
            desktop = 'none';
            microphone = '線路 (2- AVerMedia Live Gamer HD 2)';

            break;
    }

	*/

    screenService.createMode(plan);
    liveService.path_init(area);

    if (preview_first_start) {

        setTimeout(() => {

            previewService.start_preview(); //啟動訊源畫面

            preview_start_time = true;

        }, 10000);

    }
	
	
	wss.broadcast = broadcast = (msg) => {
		wss.clients.forEach((client) => {
			client.send(msg);
		});
	};

	wss.on('connection', (ws) => {

    ws.on('message', (data) => process_event(ws, data));

    ws.send(JSON.stringify({ type: 'pageInit', data: scheduleControl.getPageInitStatus() }));

	});

	recordService.init_pool(mysql_pool);
	ptzService.init_pool(mysql_pool);
	
	scheduleControl.initModule(previewService, screenService, recordService, liveService, ptzService, wss); //將各模組載入到排程去控制


} catch (err) {
	
	console.log(err);

    console.log('讀取不到必要檔案!');
    process.exit(1);

}

const openAutoPreview = autoExec.scheduleJob('0 0 7 * * *', () => {

    if (!previewService.getPreivewStatus()) {

        previewService.start_preview(desktop, camera2, camera1, microphone); //啟動訊源畫面

        preview_start_time = true;

        console.log('開啟服務囉!!');

    }

});

const closeAutoPreview = autoExec.scheduleJob('0 0 22 * * *', () => {

    if (previewService.getPreivewStatus()) {

        previewService.stop_preview();

        preview_start_time = false;

        console.log('關閉服務囉!!');

    }

});

const openSchedule = autoExec.scheduleJob('*/1 0-23 * * *', () =>{
	
	scheduleControl.checkCalendar(); //檢查錄影排程
	
});


const process_event = (ws, data) => {

    if (preview_start_time) {

        let event = JSON.parse(data);

        switch (event.type) {

            case 'start_live':

                scheduleControl.start_live();

                break;

            case 'stop_live':

                scheduleControl.stop_live();

                break;

            case 'start_record':

                scheduleControl.start_record(event);

                break;


            case 'stop_record':

                scheduleControl.stop_record();

                break;

            case 'change_screen':

                scheduleControl.change_screen();

                break;


            case 'coruse_setting':

                scheduleControl.set_course_information(event.data);


                break;

            case 'getPresets':
			 getPreset.getPreset();

                break;

            case 'camera_gotoPreset':

                scheduleControl.change_camera_preset(event.data);

                break;

	    case 'runPTZ':
		ptzService.runPTZ(event.data);

		break;
        }

    } else {

        ws.send(JSON.stringify({ type: 'preview_no_control', data: 'request' }));

    }
};
