var Mpeg1Muxer, child_process, events, util

child_process = require('child_process')

util = require('util')

events = require('events')

Mpeg1Muxer = function(options) {
  var key
  this.url = options.url
  this.ffmpegOptions = options.ffmpegOptions
  this.exitCode = undefined
  this.additionalFlags = this.ffmpegOptions;
  /*if (this.ffmpegOptions) {
    for (key in this.ffmpegOptions) {
      this.additionalFlags.push(key)
      if (String(this.ffmpegOptions[key]) !== '') {
        this.additionalFlags.push(String(this.ffmpegOptions[key]))
      }
    }
  }
  */
  this.spawnOptions = [
    
	...this.additionalFlags,
	'-codec:v',
    'mpeg1video',
	'-b:v',
	'2000k',
	'-q',
	'8',
	'-codec:a',
	'aac',
	'-b:a',
	'128k',
	'-f',
    'mpegts',
    '-',
	'|',
	'ffmpeg.exe',
	'-hide_banner',
	'-loglevel',
	'error',
	'-i',
	'-',
	'-c:',
    'copy',
	'-f',
	'mpegts',
	'udp://127.0.0.1:23000',
	'-c:',
    'copy',
	'-f',
	'mpegts',
	'udp://127.0.0.1:23001',
    '-c:',
    'copy',  
	'-f',
    'mpegts',
    '-'
  ]
  this.stream = child_process.spawn('ffmpeg.exe', this.spawnOptions, {
    cwd: 'D:\\screenService\\resources' ,
	shell: true
  })
  this.inputStreamStarted = true
  this.stream.stdout.on('data', (data) => {
    return this.emit('mpeg1data', data)
  })
  this.stream.stderr.on('data', (data) => {
    return this.emit('ffmpegStderr', data)
  })
  this.stream.on('exit', (code, signal) => {
    if (code === 1) {
      console.error('RTSP stream exited with error')
      this.exitCode = 1
      return this.emit('exitWithError')
    }
  })
  return this
}

util.inherits(Mpeg1Muxer, events.EventEmitter)

module.exports = Mpeg1Muxer
