declare let Constants: Constants;
interface Constants {
    COMMAND_TIMEOUT: number;
    HEADERMASK_SOURCE: number;
    HEADERMASK_RECIPIENT: number;
    HEADERMASK_BROADCAST: number;
    MSGTYPE_COMMAND: number;
    MSGTYPE_IF_CLEAR: number;
    MSGTYPE_INQUIRY: number;
    MSGTYPE_CANCEL: number;
    MSGTYPE_ADDRESS_SET: number;
    MSGTYPE_NETCHANGE: number;
    MSGTYPE_ACK: number;
    MSGTYPE_COMPLETE: number;
    MSGTYPE_ERROR: number;
    DATATYPE_INTERFACE: number;
    DATATYPE_CAMERA: number;
    DATATYPE_OPERATION: number;
    CAM_POWER: number;
    CAM_SLEEP_TIME: number;
    CAM_ICR: number;
    CAM_AUTO_ICR: number;
    CAM_AUTO_ICR_THRESHOLD: number;
    CAM_GAIN: number;
    CAM_GAIN_LIMIT: number;
    CAM_GAIN_DIRECT: number;
    CAM_RGAIN: number;
    CAM_RGAIN_DIRECT: number;
    CAM_BGAIN: number;
    CAM_BGAIN_DIRECT: number;
    CAM_ZOOM: number;
    CAM_DZOOM: number;
    CAM_ZOOM_DIRECT: number;
    CAM_FOCUS: number;
    CAM_FOCUS_IR_CORRECTION: number;
    CAM_FOCUS_TRIGGER: number;
    CAM_FOCUS_INFINITY: number;
    CAM_FOCUS_NEAR_LIMIT_POS: number;
    CAM_FOCUS_AUTO: number;
    CAM_FOCUS_DIRECT: number;
    CAM_FOCUS_AF_MODE: number;
    CAM_FOCUS_AF_INTERVAL: number;
    CAM_FOCUS_SENSE_HIGH: number;
    CAM_WB_MODE: number;
    CAM_WB_TRIGGER: number;
    CAM_EXPOSURE_MODE: number;
    CAM_SHUTTER_SLOW_AUTO: number;
    CAM_SHUTTER: number;
    CAM_SHUTTER_DIRECT: number;
    CAM_IRIS: number;
    CAM_IRIS_DIRECT: number;
    CAM_BRIGHT: number;
    CAM_BRIGHT_DIRECT: number;
    CAM_EXP_COMP: number;
    CAM_EXP_COMP_ENABLE: number;
    CAM_EXP_COMP_DIRECT: number;
    CAM_BACKLIGHT: number;
    CAM_WIDE_D: number;
    CAM_WIDE_D_REFRESH: number;
    CAM_WIDE_D_SET: number;
    CAM_APERTURE: number;
    CAM_APERTURE_DIRECT: number;
    CAM_HIRES_ENABLE: number;
    CAM_NOISE_REDUCTION: number;
    CAM_GAMMA: number;
    CAM_HIGH_SENSITIVITY: number;
    CAM_FREEZE: number;
    CAM_EFFECT: number;
    CAM_EFFECT_DIGITAL: number;
    CAM_EFFECT_LEVEL: number;
    CAM_MEMORY: number;
    CAM_ID_WRITE: number;
    CAM_CHROMA_SUPPRESS: number;
    CAM_COLOR_GAIN: number;
    CAM_COLOR_HUE: number;
    OP_MENU_SCREEN: number;
    OP_VIDEO_FORMAT: number;
    OP_VIDEO_FORMAT_I_NOW: number;
    OP_VIDEO_FORMAT_I_NEXT: number;
    OP_PAN_DRIVE: number;
    OP_PAN_ABSOLUTE: number;
    OP_PAN_RELATIVE: number;
    OP_PAN_MAX_SPEED: number;
    OP_PAN_POS: number;
    OP_PAN_HOME: number;
    OP_PAN_RESET: number;
    OP_PAN_LIMIT: number;
    OP_PAN_STATUS: number;
    OP_IR_RECEIVE: number;
    OP_IR_RETURN_ON: number[];
    OP_IR_RETURN_OFF: number[];
    OP_INFO_DISPLAY_ON: number[];
    OP_INFO_DISPLAY_OFF: number[];
    OP_IR_CONDITION: number[];
    OP_FAN_CONDITION: number[];
    OP_INFORMATION_DISPLAY_STATUS: number[];
    OP_VERSION_INQUIRY: number[];
    CAM_LENS_INQUIRY: number[];
    CAM_IMAGE_INQUIRY: number[];
    CMD_CAM_VAL_RESET: number;
    CMD_CAM_VAL_CLEAR: number;
    CMD_CAM_VAL_UP: number;
    CMD_CAM_VAL_DOWN: number;
    CMD_CAM_ZOOM_STOP: number;
    CMD_CAM_ZOOM_TELE: number;
    CMD_CAM_ZOOM_WIDE: number;
    CMD_CAM_ZOOM_TELE_WITH_SPEED: number;
    CMD_CAM_ZOOM_WIDE_WITH_SPEED: number;
    CMD_CAM_FOCUS_STOP: number;
    CMD_CAM_FOCUS_FAR: number;
    CMD_CAM_FOCUS_NEAR: number;
    CMD_CAM_FOCUS_FAR_WITH_SPEED: number;
    CMD_CAM_FOCUS_NEAR_WITH_SPEED: number;
    CMD_CAM_FOCUS_TRIGGER_NOW: number;
    CMD_CAM_FOCUS_TRIGGER_INF: number;
    CMD_CAM_WB_TRIGGER_NOW: number;
    DATA_RESET: number;
    DATA_MORE: number;
    DATA_LESS: number;
    DATA_ONVAL: number;
    DATA_OFFVAL: number;
    DATA_TOGGLEVAL: number;
    DATA_MEMORY_RESET: number;
    DATA_MEMORY_SET: number;
    DATA_MEMORY_RECALL: number;
    DATA_IR_CORRECTION_ENABLED: number;
    DATA_CAM_FOCUS_MODE_AUTO: number;
    DATA_CAM_FOCUS_MODE_MANUAL: number;
    DATA_CAM_FOCUS_MODE_TOGGLE: number;
    DATA_CAM_AUTOFOCUS_ON_MOVEMENT: number;
    DATA_CAM_AUTOFOCUS_ON_INTERVAL: number;
    DATA_CAM_AUTOFOCUS_ON_ZOOM: number;
    DATA_CAM_WB_MODE_AUTO: number;
    DATA_CAM_WB_MODE_INDOOR: number;
    DATA_CAM_WB_MODE_OUTDOOR: number;
    DATA_CAM_WB_MODE_ON_TRIGGER: number;
    DATA_CAM_WB_MODE_MANUAL: number;
    DATA_CAM_EXPOSURE_MODE_AUTO: number;
    DATA_CAM_EXPOSURE_MODE_MANUAL: number;
    DATA_CAM_EXPOSURE_MODE_SHUTTER: number;
    DATA_CAM_EXPOSURE_MODE_IRIS: number;
    DATA_CAM_EXPOSURE_MODE_BRIGHT: number;
    DATA_CAM_WIDE_DYN_AUTO: number;
    DATA_CAM_WIDE_DYN_RATIO: number;
    DATA_CAM_WIDE_DYN_ON: number;
    DATA_CAM_WIDE_DYN_OFF: number;
    DATA_CAM_WIDE_DYN_HIST: number;
    DATA_EFFECT_OFF: number;
    DATA_EFFECT_PASTEL: number;
    DATA_EFFECT_NEGATIVE: number;
    DATA_EFFECT_SEPIA: number;
    DATA_EFFECT_BW: number;
    DATA_EFFECT_SOLAR: number;
    DATA_EFFECT_MOSAIC: number;
    DATA_EFFECT_SLIM: number;
    DATA_EFFECT_STRETCH: number;
    DATA_EFFECT_STILL: number;
    DATA_EFFECT_FLASH: number;
    DATA_EFFECT_LUMI: number;
    DATA_EFFECT_TRAIL: number;
    DATA_PANLEFT: number;
    DATA_TILTUP: number;
    DATA_PANRIGHT: number;
    DATA_TILTDOWN: number;
    DATA_PANSTOP: number;
    DATA_TILTSTOP: number;
    DATA_PANTILT_UR: number;
    DATA_PANTILT_DL: number;
    PAN_MAXL: number;
    PAN_MAXR: number;
    PAN_MAXU: number;
    PAN_MAXD: number;
    PAN_PAN_UNK: number;
    PAN_TILT_UNK: number;
    PAN_MOVING: number;
    PAN_MOVE_DONE: number;
    PAN_MOVE_FAIL: number;
    PAN_NR: number;
    PAN_INIT: number;
    PAN_READY: number;
    PAN_INIT_FAIL: number;
    ERROR_SYNTAX: number;
    ERROR_BUFFER_FULL: number;
    ERROR_CANCELLED: number;
    ERROR_INVALID_BUFFER: number;
    ERROR_COMMAND_FAILED: number;
    SONY_FOCUS_NEAR_LIMIT_SETTINGS: number[];
    SONY_OPTICAL_ZOOM_PRESETS: number[];
    SONY_DIGITAL_ZOOM_PRESETS: number[];
}
export { Constants };
