const onvif = require('node-onvif');
let mysql_pool = undefined;

const init_pool = (pool) =>{

	mysql_pool = pool;

};

const setPreset = presetToken => {

    let device = new onvif.OnvifDevice({
	    xaddr: 'http://172.0.0.3:81/onvif/device_service',
        user: 'admin',
        pass: 'admin'
    });

    device.init().then(() => {
        let ptz = device.services.ptz;
        if(!ptz) {
          throw new Error('Your ONVIF network camera does not support the PTZ service.');
        }
        let profile = device.getCurrentProfile();
      
        let params = {
            'ProfileToken': profile['token'],
            'PresetToken': presetToken,
            'PresetName' : presetToken,
           };
      
              return ptz.setPreset(params);
      
       }).then((result) => {
        console.log(JSON.stringify(result.data, null, '  '));
      }).catch((error) => {
        console.error(error);
      });


};

const gotoPreset = presetToken => {

mysql_pool.getConnection((err, con) => {

    if (err) {

      console.log(err);

    } else {

      con.query('SELECT * FROM camera_angle where id =' + presetToken, (err, result, fields) => {

        if (err) {

          console.log(err);

        }

	      let device = new onvif.OnvifDevice({
        xaddr: 'http://172.0.0.3:81/onvif/device_service',
        user: 'admin',
        pass: 'admin'
    });

    device.init().then(() => {
        let ptz = device.services.ptz;
        if (!ptz) {
            throw new Error('Your ONVIF network camera does not support the PTZ service.');
        }
        let profile = device.getCurrentProfile();

       	let params = {
  		'ProfileToken': profile['token'],
  		'Position'    : {'x': parseFloat(result[0].x), 'y': parseFloat(result[0].y), 'z': parseFloat(result[0].z)},
  		'Speed'       : {'x': 1, 'y': 1, 'z': 1}
};

        return ptz.absoluteMove(params);

    }).then((result) => {
        console.log(JSON.stringify(result.data, null, '  '));
    }).catch((error) => {
        console.error(error);
    });



        con.release();

      });

    }

  });
   
};

const removePreset = presetToken => {

    let device = new onvif.OnvifDevice({
        xaddr: 'http://172.0.0.3:81/onvif/device_service',
        user: 'admin',
        pass: 'admin'
    });

    device.init().then(() => {
        let ptz = device.services.ptz;
        if(!ptz) {
          throw new Error('Your ONVIF network camera does not support the PTZ service.');
        }
        let profile = device.getCurrentProfile();
      
        let params = {
            'ProfileToken': profile['token'],
            'PresetToken' : presetToken,
           };
      
              return ptz.removePreset(params);
      
       }).then((result) => {
        console.log(JSON.stringify(result.data, null, '  '));
      }).catch((error) => {
        console.error(error);
      });


};

const runPTZ = (action) => {
        let device = new onvif.OnvifDevice({
		xaddr: 'http://172.0.0.3:81/onvif/device_service',
                user: 'admin',
                pass: 'admin'
        });


	   device.init().then(() => {
                let ptz = device.services.ptz;
                if (!ptz) {
                        throw new Error('Your ONVIF network camera does not support the PTZ service.');
                }
                let profile = device.getCurrentProfile();

                if (action.mode == 'stop') {


                        let params = {
                                'ProfileToken': profile['token'],
                                'PanTilt': true,
                                'Zoom': true
                        };

                        return ptz.stop(params);

                } else {
			console.log(action.mode)
                        let move = undefined;
                        switch (action.mode) {

                                case 'up':

                                        move = { 'x': 0, 'y': 0.5, 'z': 0 };

                                        break;

                                case 'bottom':

                                        move = { 'x': 0, 'y': -0.5, 'z': 0 };

                                        break;

                                case 'left':

                                        move = { 'x': -0.5, 'y': 0, 'z': 0 };

                                        break;
			        case 'right':

                                        move = { 'x': 0.5, 'y': 0, 'z': 0 };

                                        break;

                                case 'zoomIn':

                                        move = { 'x': 0, 'y': 0, 'z': 0.5 };

                                        break;

                                case 'zoomOut':

                                        move = { 'x': 0, 'y': 0, 'z': -0.5 };

                                        break;

                        }

                        let params = {
                                'ProfileToken': profile['token'],
                                'Velocity': move,

                        };

                        return ptz.continuousMove(params);

                }
        }).then((result) => {
                console.log(JSON.stringify(result.data, null, '  '));
        }).catch((error) => {
                console.error(error);
        });

};



module.exports = { setPreset, gotoPreset, removePreset, runPTZ, init_pool };
