global.previewService = undefined; //訊源模組
global.screenService = undefined; //版型切換模組
global.recordService = undefined; //錄影模組
global.liveService = undefined;//直播模組
global.ptzService = undefined;
global.wss = undefined;
const mysql = require('mysql');
var course_name = '';
var teacher_name = '';
var current_layout = '畫面1';
const pool = mysql.createPool({
  host: 'localhost',
  user: 'root',
  password: 'zang670623',
  database: 'zrs_db'
});

const initModule = (previewService, screenService, recordService, liveService, ptzService, wss) => {
	
	global.previewService = previewService;
	global.screenService = screenService;
	global.recordService = recordService;
	global.liveService = liveService;
	global.ptzService = ptzService;
	global.wss = wss;
	
};

const getPageInitStatus = () => {


    let course_data = {
        courseName: course_name,
        teacherName: teacher_name
    }

    let initStatus = {

        liveStatus: liveService.getLiveStatus(),
        recordStatus: recordService.getRecordStatus(),
        previewStatus: previewService.getPreivewStatus(),
        layout: current_layout,
        courseData: course_data

    }

    return initStatus;

}

const change_screen = () => {

    current_layout = screenService.changeScreenMode();

    wss.broadcast(JSON.stringify({ type: 'current_layout', data: current_layout }));

};


const change_camera_preset = (presetToken) =>{

    ptzService.gotoPreset(presetToken);

};

const start_record = (event) => {

    if (!recordService.getRecordStatus()) { //檢查錄影狀態是否為停止

        recordService.startRecord(event.data);

        wss.broadcast(JSON.stringify({ type: 'record_status_on', data: '錄影中' }));
		
    }

};


const stop_record = () => {

    if (recordService.getRecordStatus()) {

        recordService.stopRecord();

        wss.broadcast(JSON.stringify({ type: 'record_status_off', data: '尚未開始錄影' }));

    }

};

const start_live = () => {

    if (!liveService.getLiveStatus()) {

        liveService.startLive();

        wss.broadcast(JSON.stringify({ type: 'live_status_on', data: '直播中' }));

    }

};

const stop_live = () => {

    if (liveService.getLiveStatus()) {

        liveService.stopLive();

        wss.broadcast(JSON.stringify({ type: 'live_status_off', data: '尚未直播' }));

    }


};

const set_course_information = (information) => {

    screenService.changeCourseInformation(information);

    course_name = information.courseName;
    teacher_name = information.teacherName;
	

    let course_data = {

        courseName: course_name,
        teacherName: teacher_name

    }

    wss.broadcast(JSON.stringify({ type: 'course_information', data: course_data }));

};

const gotoScreen = (layout_number) =>{
	
	current_layout = screenService.gotoScreen(layout_number);

    wss.broadcast(JSON.stringify({ type: 'current_layout', data: current_layout }));
	
};

const checkCalendar = (previewService) =>{
/*	
	pool.getConnection((err, con) => {

     con.query("SELECT * FROM calendar WHERE startdate = NOW()", [] , (err, result, fields) => {
		  
		if(result.length > 0){
			  
			let course_data = result[0];
			  
			start_record({data:{
								course_name: course_data.title, 
								teacher_name: course_data.teach_name, 
								rec_time: course_data.rec_time,
								classroom: '藝文教室'
								}});
						
			gotoScreen(course_data.layout);
			
			set_course_information({
				courseName: course_data.title,
				teacherName: course_data.teach_name,
				classroom: '藝文教室'
			})
						
			if(course_data.isLive == '1'){
				
				start_live();
				
			}
			  
		}
		  
		con.release();

      });

  });
*/		
};

module.exports={initModule,
				stop_live,
				start_live,
				stop_record,
				start_record,
				change_screen,
				checkCalendar,
				getPageInitStatus,
				change_camera_preset,
				set_course_information};
