const os = require('os');
const user_homedir = os.homedir();
const system_volume = user_homedir.charAt(0);
const { spawn } = require('child_process');
const escapeShell = cmd => '"' + cmd.replace(/(["'$`\\])/g, '\\$1') + '"';
let screen_mode = undefined;

let current_mode = 1;

const createMode = plan =>{

	switch(plan){

		case 1:

			screen_mode = new Map([[1,'畫面1'],[3, '桌面1']]);

		break;

		case 2:

			screen_mode = new Map([[1,'畫面1'], [2,'畫面2'],[3, '桌面1'],[4,'子母畫面']]);

		break;

		case 3:

			screen_mode = new Map([[1,'畫面1'], [2,'講師電腦'], [3, '電腦講師資訊']]);

		break;

	}
};

const getScreenMode = ()=>{
	
	return screen_mode.get(current_mode);
	
};


const changeScreenMode = ()=>{
	
	if(current_mode >= screen_mode.size){
		current_mode = 0;
	}

	current_mode++;

	if(!screen_mode.has(current_mode)){

		current_mode++;
	}
	
	let changeProcess = spawn('/home/zsystem/screenService/resources/changeScreen.sh',[current_mode.toString()],{ shell: true});
	
	changeProcess.stdout.on('data', data => console.log(new TextDecoder('utf-8').decode(data)));
    changeProcess.stderr.on('data', data => console.log(new TextDecoder('utf-8').decode(data)));

    changeProcess.on('close', result =>{});
	
	return screen_mode.get(current_mode);
}

const changeCourseInformation = information =>{
	
	let courseName1 = '';
	
	let courseName2 = '';
	
	if(information.courseName.length > 12){
		
		courseName1 = information.courseName.substring(0, 12);
		
		courseName2 = information.courseName.substring(12, information.courseName.length);
		
	}else{
		
		courseName1 = information.courseName;
		
	}

	let changeProcess = spawn('/home/zsystem/screenService/resources/set_information.sh',[escapeShell(information.classroom), escapeShell(information.teacherName), escapeShell(courseName1), escapeShell(courseName2)],{ shell: true});

	
	changeProcess.stdout.on('data', data => console.log(new TextDecoder('utf-8').decode(data)));
    changeProcess.stderr.on('data', data => console.log(new TextDecoder('utf-8').decode(data)));

    changeProcess.on('close', result =>{});

};

const gotoScreen = (layout_number) =>{
	
	let changeProcess = spawn('/home/zsystem/screenService/resources/changeScreen.sh',[layout_number],{ shell: true});
	
	changeProcess.stdout.on('data', data => console.log(new TextDecoder('utf-8').decode(data)));
    changeProcess.stderr.on('data', data => console.log(new TextDecoder('utf-8').decode(data)));

    changeProcess.on('close', result =>{});
	
	current_mode = parseInt(layout_number);
	
	return screen_mode.get(current_mode);
	
};

module.exports = {
		gotoScreen,
		createMode,
        	getScreenMode,
		changeScreenMode,
		changeCourseInformation};
